// ChatSDoc.h : interface of the CChatSDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHATSDOC_H__2DD93E73_9CC5_11D5_9750_00E07DA18C35__INCLUDED_)
#define AFX_CHATSDOC_H__2DD93E73_9CC5_11D5_9750_00E07DA18C35__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CServerSock;
class CClientSock;
class CProtocolUnit;
class CChatSView;

class CChatSDoc : public CDocument
{
private:
	CServerSock* m_pServerSock;
	CChatSView* m_pView;

protected: // create from serialization only
	CChatSDoc();
	DECLARE_DYNCREATE(CChatSDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChatSDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	CClientSock* GetSocketByNick(const CString& rsNick);
	void ClientClose(CClientSock* pSocket);
	CString GetNickList() const;
	BOOL NickAlreadyIs(CString);

	void SayToAll(CString sMesg);
	BOOL IsServerRunning();
	void StopServer();
	BOOL StartServer(UINT nPort);
	void ReceiveFromClient(CClientSock* pSocket);
	void AcceptNewClient();
	virtual ~CChatSDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	CPtrList m_client_list;
	//{{AFX_MSG(CChatSDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHATSDOC_H__2DD93E73_9CC5_11D5_9750_00E07DA18C35__INCLUDED_)
