// ProtocolUnit.cpp: implementation of the CProtocolUnit class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ChatS.h"
#include "ProtocolUnit.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CProtocolUnit::CProtocolUnit()
{
	m_sCommand = "";
	m_sParam = "";
	m_sText = "";
	m_nCommand = PU_UNKNOWN;
}

CProtocolUnit::~CProtocolUnit()
{

}

void CProtocolUnit::Extract(CString &sLine)
{
	CString sTmp;
	int nPos;

	nPos = sLine.Find(' ');
	if(nPos == -1)
	{
		m_sCommand = sLine;
		m_sParam = "";
		m_sText = "";
	}
	else
	{
		m_sCommand = sLine.Left(nPos);
		sTmp = sLine.Mid(nPos+1); // XXX
		nPos = sTmp.Find(' ');

		if(nPos == -1)
		{
			m_sParam = sTmp;
			m_sText = "";
		}
		else
		{
			m_sParam = sTmp.Left(nPos);
			m_sText = "TEST";
			m_sText = sTmp.Mid(nPos+1); // XXX
		}
	}
	
	m_sCommand.MakeUpper();

	if(m_sCommand == "ERROR")
		m_nCommand = PU_ERROR;
	else 	if(m_sCommand == "SAY")
		m_nCommand = PU_SAY;
//m
	else if(m_sCommand == "JOIN")
		m_nCommand = PU_JOIN;
	else if(m_sCommand == "NICK")
		m_nCommand = PU_NICK;
	else if(m_sCommand == "BYE")
		m_nCommand = PU_BYE;
	else if(m_sCommand == "LIST")
		m_nCommand = PU_LIST;
	else if(m_sCommand == "WELCOME")
		m_nCommand = PU_WELCOME;
	else if(m_sCommand == "WHISPER")
		m_nCommand = PU_WHISPER;
	else if(m_sCommand == "DISCONNECT")
		m_nCommand = PU_DISCONNECT;
	else if(m_sCommand == "DOWN")
		m_nCommand = PU_DOWN;
	else
		m_nCommand = PU_UNKNOWN;
}

CString CProtocolUnit::GetCommand() const
{
	return m_sCommand;
}

CString CProtocolUnit::GetParam() const
{
	return m_sParam;
}

CString CProtocolUnit::GetText() const
{
	return m_sText;
}

int CProtocolUnit::GetCommandID() const
{
	return m_nCommand;
}
